<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): AstNode.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_ast_node_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">AstNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2014, Freescale Semiconductor, Inc.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright 2016 NXP</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * All rights reserved.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without modification,</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * o Redistributions of source code must retain the above copyright notice, this list</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *   of conditions and the following disclaimer.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * o Redistributions in binary form must reproduce the above copyright notice, this</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *   list of conditions and the following disclaimer in the documentation and/or</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *   other materials provided with the distribution.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * o Neither the name of the copyright holder nor the names of its</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   contributors may be used to endorse or promote products derived from this</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   software without specific prior written permission.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#ifndef _EMBEDDED_RPC__ASTNODE_H_</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#define _EMBEDDED_RPC__ASTNODE_H_</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;Token.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &quot;smart_ptr.h&quot;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;stack&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;typeinfo&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment">// Classes</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceerpcgen.html">erpcgen</a> {</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html">   57</a></span>&#160;<span class="keyword">class </span><a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;{</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">typedef</span> std::map&lt;std::string, Value *&gt; attribute_map_t;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">typedef</span> std::vector&lt;AstNode *&gt; child_list_t;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">typedef</span> child_list_t::iterator iterator;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">typedef</span> child_list_t::const_iterator const_iterator;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#af93e5482a8c032afb73a0443bdfb8c10">   77</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html#af93e5482a8c032afb73a0443bdfb8c10">AstNode</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;token)</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    : <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>(token)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    , <a class="code" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">m_parent</a>(nullptr)</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    {</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a85358932700cac01ee23a220205bdfba">   95</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html#a85358932700cac01ee23a220205bdfba">AstNode</a>(<a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;token, <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *parent)</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    : <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>(token)</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    , <a class="code" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">m_parent</a>(parent)</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    {</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html#af93e5482a8c032afb73a0443bdfb8c10">AstNode</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> &amp;other);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> &amp;<a class="code" href="classerpcgen_1_1_ast_node.html#a0953078572b027d3fe1a0b013ea14318">operator=</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> &amp;other);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classerpcgen_1_1_ast_node.html#aeb0797e0870237b6adb6398fc81ebe6b">~AstNode</a>();</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#af578fd9636566a042f6fd0c9cfaa3cd1">  138</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#af578fd9636566a042f6fd0c9cfaa3cd1">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classerpcgen_1_1_ast_node.html#af93e5482a8c032afb73a0443bdfb8c10">AstNode</a>(*<span class="keyword">this</span>); }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#af340a5e5babee2b8abd6c264af0f288f">  145</a></span>&#160;    <span class="keyword">virtual</span> std::string <a class="code" href="classerpcgen_1_1_ast_node.html#af340a5e5babee2b8abd6c264af0f288f">nodeName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">typeid</span>(*this).name(); }</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a4644802709f33aabbeed7450d0f5ee1f">  156</a></span>&#160;    <a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;<a class="code" href="classerpcgen_1_1_ast_node.html#a4644802709f33aabbeed7450d0f5ee1f">getToken</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>; }</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a56d14536ef1c2dd5ddf2e02bfa87e2eb">  165</a></span>&#160;    <span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;<a class="code" href="classerpcgen_1_1_ast_node.html#a56d14536ef1c2dd5ddf2e02bfa87e2eb">getToken</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>; }</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#ac87ae686f256b14b79379728ce953358">  172</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac87ae686f256b14b79379728ce953358">setToken</a>(<a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;token) { <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a> = token; }</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a8c085f49a7b1b3fd70184c886874b881">  179</a></span>&#160;    <a class="code" href="class_value.html">Value</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#a8c085f49a7b1b3fd70184c886874b881">getTokenValue</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>.<a class="code" href="classerpcgen_1_1_token.html#a62502955d98b6828f9b63c6ea93d1b69">getValue</a>(); }</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#ad56b39de022d91dc3a72f81be94f0783">  186</a></span>&#160;    std::string <a class="code" href="classerpcgen_1_1_ast_node.html#ad56b39de022d91dc3a72f81be94f0783">getTokenString</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>.<a class="code" href="classerpcgen_1_1_token.html#a62502955d98b6828f9b63c6ea93d1b69">getValue</a>() ? <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>.<a class="code" href="classerpcgen_1_1_token.html#a62502955d98b6828f9b63c6ea93d1b69">getValue</a>()-&gt;toString() : <span class="stringliteral">&quot;&quot;</span>; }</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a71886c95f8fe70f115ccba2883cb4f08">  196</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#a71886c95f8fe70f115ccba2883cb4f08">getParent</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">m_parent</a>; }</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#ade4a3ceb22c961deab26c534a0d4f512">  203</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ade4a3ceb22c961deab26c534a0d4f512">setParent</a>(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *newParent) { <a class="code" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">m_parent</a> = newParent; }</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a945c2572ca43f2864c396770a1c5e29c">  213</a></span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a945c2572ca43f2864c396770a1c5e29c">attributeCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac0915f962b3997e08228ae38a61d935d">m_attributes</a>.size(); }</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ad2b918b3e6a1d776cd2d97fc35194889">hasAttribute</a>(<span class="keyword">const</span> std::string &amp;name) <span class="keyword">const</span>;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <a class="code" href="class_value.html">Value</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#abbb9fcfb549677f64e71b3345b17ef53">getAttribute</a>(<span class="keyword">const</span> std::string &amp;name);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a84856c47428fc75851c9d1dce3d0d674">setAttribute</a>(<span class="keyword">const</span> std::string &amp;name, <a class="code" href="class_value.html">Value</a> *node);</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#abd2e5d91497abeab14f18bd2320e023d">removeAttribute</a>(<span class="keyword">const</span> std::string &amp;name);</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div><div class="line"><a name="l00282"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a378dcdd292eb8b68be6e453871de8754">  282</a></span>&#160;    <a class="code" href="class_value.html">Value</a> *&amp;<a class="code" href="classerpcgen_1_1_ast_node.html#a378dcdd292eb8b68be6e453871de8754">operator[]</a>(<span class="keyword">const</span> std::string &amp;name) { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac0915f962b3997e08228ae38a61d935d">m_attributes</a>[name]; }</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a3c0a8040c3cf0ea621544bffdc44a033">appendChild</a>(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a1054ec1fa85752e99ffa3adfb72b1bb2">  303</a></span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a1054ec1fa85752e99ffa3adfb72b1bb2">childCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>.size(); }</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a651cbcd73e0c4c0b75b8c21334bf3bbd">  315</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#a651cbcd73e0c4c0b75b8c21334bf3bbd">getChild</a>(<span class="keywordtype">int</span> index)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>[index]; }</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classerpcgen_1_1_ast_node.html#aed311b11f950bd3cf65e1a66e96a3cc1">getIndexOfChild</a>(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *child);</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a077d782a18bdfb22d8a10a828481088c">getIndex</a>();</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#a50e36414d2fdeabc1197cad5ea014d77">replaceChild</a>(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *original, <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *replacement);</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_node.html#aa809c3fe3989fd4e0f8fd6900b378e9f">reverseExpr</a>();</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div><div class="line"><a name="l00373"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a649844703d0856c1ac202a596e8cd0dc">  373</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *&amp;<a class="code" href="classerpcgen_1_1_ast_node.html#a649844703d0856c1ac202a596e8cd0dc">operator[]</a>(<span class="keywordtype">int</span> index) { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>[index]; }</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a007f4478774729c7dcaba8c79a63c4df">  387</a></span>&#160;    <span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#a007f4478774729c7dcaba8c79a63c4df">operator[]</a>(<span class="keywordtype">int</span> index)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>[index]; }</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    <span class="keyword">inline</span> iterator begin() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>.begin(); }</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    <span class="keyword">inline</span> iterator end() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>.end(); }</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="keyword">inline</span> const_iterator begin()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>.begin(); }</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keyword">inline</span> const_iterator end()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>.end(); }</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    std::string <a class="code" href="classerpcgen_1_1_ast_node.html#ab2dfef2691fc7d9acaa2731732cb7e6f">getDescription</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00406"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">  406</a></span>&#160;    <a class="code" href="classerpcgen_1_1_token.html">Token</a> <a class="code" href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">m_token</a>;                </div><div class="line"><a name="l00407"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">  407</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">m_parent</a>;            </div><div class="line"><a name="l00408"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#ac0915f962b3997e08228ae38a61d935d">  408</a></span>&#160;    attribute_map_t <a class="code" href="classerpcgen_1_1_ast_node.html#ac0915f962b3997e08228ae38a61d935d">m_attributes</a>; </div><div class="line"><a name="l00409"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">  409</a></span>&#160;    child_list_t <a class="code" href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">m_children</a>;      </div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;};</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;</div><div class="line"><a name="l00415"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html">  415</a></span>&#160;<span class="keyword">class </span><a class="code" href="classerpcgen_1_1_ast_printer.html">AstPrinter</a></div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;{</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00425"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html#a67cc65aed0991ae72e969f404477c87e">  425</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_printer.html#a67cc65aed0991ae72e969f404477c87e">AstPrinter</a>(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *root)</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    : m_root(root)</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;    , m_depth(0)</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    {</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    }</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;</div><div class="line"><a name="l00438"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html#a3834f6acafd99743fd8140ac2f941abc">  438</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_ast_printer.html#a3834f6acafd99743fd8140ac2f941abc">dispatch</a>() { <a class="code" href="classerpcgen_1_1_ast_printer.html#a3834f6acafd99743fd8140ac2f941abc">dispatch</a>(m_root, 0); }</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <span class="keywordtype">void</span> dispatch(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <span class="keywordtype">int</span> childIndex = 0);</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    <span class="keywordtype">void</span> print(<a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *node, <span class="keywordtype">int</span> childIndex = 0);</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00460"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html#a6eded3139be37154915ee9f46223f740">  460</a></span>&#160;    <a class="code" href="classerpcgen_1_1_ast_node.html">AstNode</a> *<a class="code" href="classerpcgen_1_1_ast_printer.html#a6eded3139be37154915ee9f46223f740">m_root</a>;              </div><div class="line"><a name="l00461"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html#a04849a941fff5f0a56be09cd62cabaee">  461</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classerpcgen_1_1_ast_printer.html#a04849a941fff5f0a56be09cd62cabaee">m_depth</a>;                  </div><div class="line"><a name="l00462"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_ast_printer.html#af3aaf1115d98aab20242a7ccb82d0312">  462</a></span>&#160;    std::stack&lt;int&gt; <a class="code" href="classerpcgen_1_1_ast_printer.html#af3aaf1115d98aab20242a7ccb82d0312">m_depthStack</a>; </div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;    <span class="keywordtype">void</span> printIndent(<span class="keywordtype">int</span> indent) <span class="keyword">const</span>;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;};</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;} <span class="comment">// namespace erpcgen</span></div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="preprocessor">#endif // _EMBEDDED_RPC__ASTNODE_H_</span></div><div class="ttc" id="classerpcgen_1_1_ast_node_html_a651cbcd73e0c4c0b75b8c21334bf3bbd"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a651cbcd73e0c4c0b75b8c21334bf3bbd">erpcgen::AstNode::getChild</a></div><div class="ttdeci">AstNode * getChild(int index) const </div><div class="ttdoc">This function return child node from node children. </div><div class="ttdef"><b>Definition:</b> AstNode.h:315</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_af93e5482a8c032afb73a0443bdfb8c10"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#af93e5482a8c032afb73a0443bdfb8c10">erpcgen::AstNode::AstNode</a></div><div class="ttdeci">AstNode(const Token &amp;token)</div><div class="ttdoc">This function is constructor of AstNode class. </div><div class="ttdef"><b>Definition:</b> AstNode.h:77</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a4644802709f33aabbeed7450d0f5ee1f"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a4644802709f33aabbeed7450d0f5ee1f">erpcgen::AstNode::getToken</a></div><div class="ttdeci">Token &amp; getToken()</div><div class="ttdoc">This function returns token of this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:156</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ad56b39de022d91dc3a72f81be94f0783"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ad56b39de022d91dc3a72f81be94f0783">erpcgen::AstNode::getTokenString</a></div><div class="ttdeci">std::string getTokenString()</div><div class="ttdoc">This function returns string representation of this node token value. </div><div class="ttdef"><b>Definition:</b> AstNode.h:186</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ade4a3ceb22c961deab26c534a0d4f512"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ade4a3ceb22c961deab26c534a0d4f512">erpcgen::AstNode::setParent</a></div><div class="ttdeci">void setParent(AstNode *newParent)</div><div class="ttdoc">This function set parent for this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:203</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_abbb9fcfb549677f64e71b3345b17ef53"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#abbb9fcfb549677f64e71b3345b17ef53">erpcgen::AstNode::getAttribute</a></div><div class="ttdeci">Value * getAttribute(const std::string &amp;name)</div><div class="ttdoc">This function return attribute from AstNode attributes. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:128</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a378dcdd292eb8b68be6e453871de8754"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a378dcdd292eb8b68be6e453871de8754">erpcgen::AstNode::operator[]</a></div><div class="ttdeci">Value *&amp; operator[](const std::string &amp;name)</div><div class="ttdoc">Square brackets. </div><div class="ttdef"><b>Definition:</b> AstNode.h:282</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_abd2e5d91497abeab14f18bd2320e023d"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#abd2e5d91497abeab14f18bd2320e023d">erpcgen::AstNode::removeAttribute</a></div><div class="ttdeci">void removeAttribute(const std::string &amp;name)</div><div class="ttdoc">This function remove attribute from AstNode attributes. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:146</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_aed311b11f950bd3cf65e1a66e96a3cc1"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#aed311b11f950bd3cf65e1a66e96a3cc1">erpcgen::AstNode::getIndexOfChild</a></div><div class="ttdeci">size_t getIndexOfChild(AstNode *child)</div><div class="ttdoc">This function return index of searched child node. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:163</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ac87ae686f256b14b79379728ce953358"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ac87ae686f256b14b79379728ce953358">erpcgen::AstNode::setToken</a></div><div class="ttdeci">void setToken(Token &amp;token)</div><div class="ttdoc">This function set token to this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:172</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a8709501b1d20303735df9cb03b8b5e3f"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a8709501b1d20303735df9cb03b8b5e3f">erpcgen::AstNode::m_token</a></div><div class="ttdeci">Token m_token</div><div class="ttdef"><b>Definition:</b> AstNode.h:406</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a71886c95f8fe70f115ccba2883cb4f08"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a71886c95f8fe70f115ccba2883cb4f08">erpcgen::AstNode::getParent</a></div><div class="ttdeci">AstNode * getParent() const </div><div class="ttdoc">This function returns pointer to parent node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:196</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ab2dfef2691fc7d9acaa2731732cb7e6f"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ab2dfef2691fc7d9acaa2731732cb7e6f">erpcgen::AstNode::getDescription</a></div><div class="ttdeci">std::string getDescription() const </div><div class="ttdoc">This function returns string description of the node. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:207</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a56d14536ef1c2dd5ddf2e02bfa87e2eb"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a56d14536ef1c2dd5ddf2e02bfa87e2eb">erpcgen::AstNode::getToken</a></div><div class="ttdeci">const Token &amp; getToken() const </div><div class="ttdoc">This function returns constant token of this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:165</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ac0915f962b3997e08228ae38a61d935d"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ac0915f962b3997e08228ae38a61d935d">erpcgen::AstNode::m_attributes</a></div><div class="ttdeci">attribute_map_t m_attributes</div><div class="ttdef"><b>Definition:</b> AstNode.h:408</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_af578fd9636566a042f6fd0c9cfaa3cd1"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#af578fd9636566a042f6fd0c9cfaa3cd1">erpcgen::AstNode::clone</a></div><div class="ttdeci">virtual AstNode * clone() const </div><div class="ttdoc">This function returns an exact duplicate of this object. </div><div class="ttdef"><b>Definition:</b> AstNode.h:138</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ac333a0951760389cbfbf0cac7d613d10"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ac333a0951760389cbfbf0cac7d613d10">erpcgen::AstNode::m_children</a></div><div class="ttdeci">child_list_t m_children</div><div class="ttdef"><b>Definition:</b> AstNode.h:409</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_af340a5e5babee2b8abd6c264af0f288f"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#af340a5e5babee2b8abd6c264af0f288f">erpcgen::AstNode::nodeName</a></div><div class="ttdeci">virtual std::string nodeName() const </div><div class="ttdoc">This function returns name of this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:145</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a007f4478774729c7dcaba8c79a63c4df"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a007f4478774729c7dcaba8c79a63c4df">erpcgen::AstNode::operator[]</a></div><div class="ttdeci">const AstNode * operator[](int index) const </div><div class="ttdoc">Square brackets. </div><div class="ttdef"><b>Definition:</b> AstNode.h:387</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html">erpcgen::AstNode</a></div><div class="ttdoc">Homogeneous AST node class. </div><div class="ttdef"><b>Definition:</b> AstNode.h:57</div></div>
<div class="ttc" id="classerpcgen_1_1_token_html_a62502955d98b6828f9b63c6ea93d1b69"><div class="ttname"><a href="classerpcgen_1_1_token.html#a62502955d98b6828f9b63c6ea93d1b69">erpcgen::Token::getValue</a></div><div class="ttdeci">Value * getValue()</div><div class="ttdoc">This function returns token value. </div><div class="ttdef"><b>Definition:</b> Token.h:230</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a945c2572ca43f2864c396770a1c5e29c"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a945c2572ca43f2864c396770a1c5e29c">erpcgen::AstNode::attributeCount</a></div><div class="ttdeci">size_t attributeCount() const </div><div class="ttdoc">This function returns count of node attributes. </div><div class="ttdef"><b>Definition:</b> AstNode.h:213</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a50e36414d2fdeabc1197cad5ea014d77"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a50e36414d2fdeabc1197cad5ea014d77">erpcgen::AstNode::replaceChild</a></div><div class="ttdeci">void replaceChild(AstNode *original, AstNode *replacement)</div><div class="ttdoc">This function replace child in AstNode tree. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:199</div></div>
<div class="ttc" id="class_value_html"><div class="ttname"><a href="class_value.html">Value</a></div><div class="ttdoc">Abstract base class for values of arbitrary types. </div><div class="ttdef"><b>Definition:</b> Value.h:49</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a84856c47428fc75851c9d1dce3d0d674"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a84856c47428fc75851c9d1dce3d0d674">erpcgen::AstNode::setAttribute</a></div><div class="ttdeci">void setAttribute(const std::string &amp;name, Value *node)</div><div class="ttdoc">This function set attribute in AstNode attributes. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:141</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a1054ec1fa85752e99ffa3adfb72b1bb2"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a1054ec1fa85752e99ffa3adfb72b1bb2">erpcgen::AstNode::childCount</a></div><div class="ttdeci">size_t childCount() const </div><div class="ttdoc">This function return count of children for current node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:303</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_aa809c3fe3989fd4e0f8fd6900b378e9f"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#aa809c3fe3989fd4e0f8fd6900b378e9f">erpcgen::AstNode::reverseExpr</a></div><div class="ttdeci">void reverseExpr()</div><div class="ttdoc">This function replace children location in AstNode tree. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:182</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a649844703d0856c1ac202a596e8cd0dc"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a649844703d0856c1ac202a596e8cd0dc">erpcgen::AstNode::operator[]</a></div><div class="ttdeci">AstNode *&amp; operator[](int index)</div><div class="ttdoc">Square brackets. </div><div class="ttdef"><b>Definition:</b> AstNode.h:373</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a0953078572b027d3fe1a0b013ea14318"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a0953078572b027d3fe1a0b013ea14318">erpcgen::AstNode::operator=</a></div><div class="ttdeci">AstNode &amp; operator=(const AstNode &amp;other)</div><div class="ttdoc">Assignment operator. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:71</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a3c0a8040c3cf0ea621544bffdc44a033"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a3c0a8040c3cf0ea621544bffdc44a033">erpcgen::AstNode::appendChild</a></div><div class="ttdeci">void appendChild(AstNode *node)</div><div class="ttdoc">This function add given node to the end of children list for current AstNode. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:154</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_ad2b918b3e6a1d776cd2d97fc35194889"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#ad2b918b3e6a1d776cd2d97fc35194889">erpcgen::AstNode::hasAttribute</a></div><div class="ttdeci">bool hasAttribute(const std::string &amp;name) const </div><div class="ttdoc">This function find attribute in AstNode attributes. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:122</div></div>
<div class="ttc" id="classerpcgen_1_1_token_html"><div class="ttname"><a href="classerpcgen_1_1_token.html">erpcgen::Token</a></div><div class="ttdoc">Encapsulates all information about a token. </div><div class="ttdef"><b>Definition:</b> Token.h:69</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_aeb0797e0870237b6adb6398fc81ebe6b"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#aeb0797e0870237b6adb6398fc81ebe6b">erpcgen::AstNode::~AstNode</a></div><div class="ttdeci">virtual ~AstNode()</div><div class="ttdoc">This function is destructor of AstNode class. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:101</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html_a6eded3139be37154915ee9f46223f740"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html#a6eded3139be37154915ee9f46223f740">erpcgen::AstPrinter::m_root</a></div><div class="ttdeci">AstNode * m_root</div><div class="ttdef"><b>Definition:</b> AstNode.h:460</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html_a3834f6acafd99743fd8140ac2f941abc"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html#a3834f6acafd99743fd8140ac2f941abc">erpcgen::AstPrinter::dispatch</a></div><div class="ttdeci">void dispatch()</div><div class="ttdoc">This function call for dispatch function. </div><div class="ttdef"><b>Definition:</b> AstNode.h:438</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a077d782a18bdfb22d8a10a828481088c"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a077d782a18bdfb22d8a10a828481088c">erpcgen::AstNode::getIndex</a></div><div class="ttdeci">size_t getIndex()</div><div class="ttdoc">This function return index of current node in parent&amp;#39;s list of children. </div><div class="ttdef"><b>Definition:</b> AstNode.cpp:177</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a6b1ce2ea174015570a48d8ca394e00fd"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a6b1ce2ea174015570a48d8ca394e00fd">erpcgen::AstNode::m_parent</a></div><div class="ttdeci">AstNode * m_parent</div><div class="ttdef"><b>Definition:</b> AstNode.h:407</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a8c085f49a7b1b3fd70184c886874b881"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a8c085f49a7b1b3fd70184c886874b881">erpcgen::AstNode::getTokenValue</a></div><div class="ttdeci">Value * getTokenValue()</div><div class="ttdoc">This function returns value of token of this node. </div><div class="ttdef"><b>Definition:</b> AstNode.h:179</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html">erpcgen::AstPrinter</a></div><div class="ttdoc">Dumps an AST tree. </div><div class="ttdef"><b>Definition:</b> AstNode.h:415</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html_a67cc65aed0991ae72e969f404477c87e"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html#a67cc65aed0991ae72e969f404477c87e">erpcgen::AstPrinter::AstPrinter</a></div><div class="ttdeci">AstPrinter(AstNode *root)</div><div class="ttdoc">This function is constructor of AstPrinter class. </div><div class="ttdef"><b>Definition:</b> AstNode.h:425</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html_a04849a941fff5f0a56be09cd62cabaee"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html#a04849a941fff5f0a56be09cd62cabaee">erpcgen::AstPrinter::m_depth</a></div><div class="ttdeci">int m_depth</div><div class="ttdef"><b>Definition:</b> AstNode.h:461</div></div>
<div class="ttc" id="namespaceerpcgen_html"><div class="ttname"><a href="namespaceerpcgen.html">erpcgen</a></div><div class="ttdef"><b>Definition:</b> AstNode.h:47</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_node_html_a85358932700cac01ee23a220205bdfba"><div class="ttname"><a href="classerpcgen_1_1_ast_node.html#a85358932700cac01ee23a220205bdfba">erpcgen::AstNode::AstNode</a></div><div class="ttdeci">AstNode(Token &amp;token, AstNode *parent)</div><div class="ttdoc">This function is constructor of AstNode class. </div><div class="ttdef"><b>Definition:</b> AstNode.h:95</div></div>
<div class="ttc" id="classerpcgen_1_1_ast_printer_html_af3aaf1115d98aab20242a7ccb82d0312"><div class="ttname"><a href="classerpcgen_1_1_ast_printer.html#af3aaf1115d98aab20242a7ccb82d0312">erpcgen::AstPrinter::m_depthStack</a></div><div class="ttdeci">std::stack&lt; int &gt; m_depthStack</div><div class="ttdef"><b>Definition:</b> AstNode.h:462</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
